import { Action } from '@ngrx/store';
import { WorkItemUI } from './../models/work-item';
export declare const UPDATE = "[column workitem] Update";
export declare const UPDATE_SUCCESS = "[column workitem] UpdateSuccess";
export declare const UPDATE_ERROR = "[column workitem] UpdateError";
export declare class Update implements Action {
    payload: {
        workItem: WorkItemUI;
        reorder: {
            workitem: WorkItemUI;
            destinationWorkitemID: string;
            direction: string;
        };
        prevColumnId: string;
    };
    constructor(payload: {
        workItem: WorkItemUI;
        reorder: {
            workitem: WorkItemUI;
            destinationWorkitemID: string;
            direction: string;
        };
        prevColumnId: string;
    });
    readonly type: string;
}
export declare class UpdateSuccess implements Action {
    payload: {
        workItemId: string;
        prevColumnId: string;
        newColumnIds: string[];
    };
    constructor(payload: {
        workItemId: string;
        prevColumnId: string;
        newColumnIds: string[];
    });
    readonly type: string;
}
export declare class UpdateError implements Action {
    payload: {
        prevColumnId: string;
        newColumnIds: string[];
    };
    constructor(payload: {
        prevColumnId: string;
        newColumnIds: string[];
    });
    readonly type: string;
}
export declare type All = Update | UpdateSuccess | UpdateError;
