import { Action } from '@ngrx/store';
import { IterationState } from '../states/iteration.state';
import { IterationUI } from './../models/iteration.model';
export declare const ADD = "[Iteration] Add";
export declare const UPDATE = "[Iteration] Update";
export declare const GET = "[Iteration] Get";
export declare const GET_SUCCESS = "[Iteration] GetSuccess";
export declare const GET_ERROR = "[Iteration] GetError";
export declare const ADD_SUCCESS = "[Iteration] AddSuccess";
export declare const ADD_ERROR = "[Iteration] AddError";
export declare const UPDATE_SUCCESS = "[Iteration] UpdateSuccess";
export declare const UPDATE_ERROR = "[Iteration] UpdateError";
export declare const SELECT = "[Iteration] Select";
export declare class Add implements Action {
    payload: {
        iteration: IterationUI;
        parent: IterationUI | null;
    };
    constructor(payload: {
        iteration: IterationUI;
        parent: IterationUI | null;
    });
    readonly type: string;
}
export declare class AddSuccess implements Action {
    payload: {
        iteration: IterationUI;
        parent: IterationUI | null;
    };
    constructor(payload: {
        iteration: IterationUI;
        parent: IterationUI | null;
    });
    readonly type: string;
}
export declare class Update implements Action {
    payload: IterationUI;
    constructor(paylod: IterationUI);
    readonly type: string;
}
export declare class UpdateSuccess implements Action {
    payload: IterationUI;
    constructor(paylod: IterationUI);
    readonly type: string;
}
export declare class Get implements Action {
    readonly type: string;
}
export declare class GetSuccess implements Action {
    payload: IterationState;
    constructor(payload: IterationState);
    readonly type: string;
}
export declare class GetError implements Action {
    readonly type: string;
}
export declare class AddError implements Action {
    readonly type: string;
}
export declare class UpdateError implements Action {
    readonly type: string;
}
export declare class Select implements Action {
    payload: string | null;
    constructor(payload?: string | null);
    readonly type: string;
}
export declare type All = Add | Update | Get | GetSuccess | GetError | AddSuccess | AddError | UpdateSuccess | UpdateError | Select;
