import { Action } from '@ngrx/store';
import { UserState } from './../states/user.state';
export declare const SET = "[users] Set";
export declare const GET = "[users] Get";
export declare const GET_ERROR = "[users] GetError";
/**
 * This action class set the normalized user data
 * Be it one user or number of users we can use
 * this action to update the user state
 * The payload value is a dictionary of users
 * where the id is the key and value is the entire
 */
export declare class Set implements Action {
    payload: UserState;
    constructor(payload: UserState);
    readonly type: string;
}
/**
 * This action is used to get one user
 * from server by it's ID
 */
export declare class Get implements Action {
    payload: string;
    constructor(payload: string);
    readonly type: string;
}
export declare class GetError implements Action {
    readonly type: string;
}
export declare type All = Set | Get | GetError;
