import { EventEmitter, OnInit } from '@angular/core';
import { AuthenticationService } from 'ngx-login-client';
import { GroupTypeUI } from './../../models/group-types.model';
import { IterationUI } from './../../models/iteration.model';
import { FilterService } from './../../services/filter.service';
export declare class IterationListEntryComponent implements OnInit {
    private auth;
    private filterService;
    iteration: IterationUI;
    selected: boolean;
    collection: any[];
    witGroup: GroupTypeUI;
    showTree: string;
    showCompleted: string;
    context: 'list' | 'board';
    readonly onEditIteration: EventEmitter<IterationUI>;
    readonly onCloseIteration: EventEmitter<IterationUI>;
    readonly onCreateIteration: EventEmitter<IterationUI>;
    loggedIn: Boolean;
    queryParams: Object;
    selectedItemId: string | number;
    constructor(auth: AuthenticationService, filterService: FilterService);
    ngOnInit(): void;
    constructURL(iterationId: string): string;
    constructURLforBoard(iterationId: string): string;
    addRemoveQueryParams(iterationId: string): {
        q: string;
        showTree?: undefined;
        showCompleted?: undefined;
    } | {
        q: string;
        showTree: string;
        showCompleted: string;
    } | {
        q: string;
        showTree: string;
        showCompleted?: undefined;
    } | {
        q: string;
        showCompleted: string;
        showTree?: undefined;
    };
    toggleChildrenDisplay(iteration: any): void;
    editIteration(iteration: any): void;
    closeIteration(iteration: any): void;
    createIteration(iteration: any): void;
    calcDepth(iteration: IterationUI): string;
}
