import { OnChanges, OnDestroy, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Observable } from 'rxjs';
import { Broadcaster, Logger, Notifications } from 'ngx-base';
import { AuthenticationService } from 'ngx-login-client';
import { IterationQuery, IterationUI } from '../../models/iteration.model';
import { IterationService } from '../../services/iteration.service';
import { WorkItemService } from '../../services/work-item.service';
import { FabPlannerIterationModalComponent } from '../iterations-modal/iterations-modal.component';
import { FilterService } from './../../services/filter.service';
import { Store } from '@ngrx/store';
import { GroupTypeUI } from '../../models/group-types.model';
import { AppState } from './../../states/app.state';
export declare class IterationComponent implements OnInit, OnDestroy, OnChanges {
    private log;
    private auth;
    private broadcaster;
    private filterService;
    private iterationService;
    private notifications;
    private route;
    private workItemService;
    private store;
    private iterationQuery;
    takeFromInput: boolean;
    iterations: IterationUI[];
    collection: any[];
    sidePanelOpen: boolean;
    witGroup: GroupTypeUI;
    showTree: string;
    showCompleted: string;
    infotipText: string;
    context: 'list' | 'board';
    modal: FabPlannerIterationModalComponent;
    authUser: any;
    loggedIn: boolean;
    editEnabled: boolean;
    barchatValue: number;
    eventListeners: any[];
    treeIterations: Observable<IterationUI[]>;
    activeIterations: Observable<IterationUI[]>;
    spaceId: string;
    startedCheckingURL: boolean;
    private spaceSubscription;
    constructor(log: Logger, auth: AuthenticationService, broadcaster: Broadcaster, filterService: FilterService, iterationService: IterationService, notifications: Notifications, route: ActivatedRoute, workItemService: WorkItemService, store: Store<AppState>, iterationQuery: IterationQuery);
    ngOnInit(): void;
    ngOnChanges(): void;
    ngOnDestroy(): void;
    constructURL(iterationId: string): string;
    constructURLforBoard(iterationId: string): string;
    addRemoveQueryParams(iterationId: string): {
        q: string;
        showTree?: undefined;
        showCompleted?: undefined;
    } | {
        q: string;
        showTree: string;
        showCompleted: string;
    } | {
        q: string;
        showTree: string;
        showCompleted?: undefined;
    } | {
        q: string;
        showCompleted: string;
        showTree?: undefined;
    };
    kebabMenuClick(event: Event): void;
    onEdit(iteration: any): void;
    onClose(iteration: any): void;
    onCreateChild(iteration: any): void;
    listenToEvents(): void;
    checkURL(): void;
}
