import { AfterViewChecked, ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Store } from '@ngrx/store';
import { DragulaService } from 'ng2-dragula';
import { BoardQuery, BoardUIQuery } from '../../models/board.model';
import { WorkItemQuery, WorkItemUI } from '../../models/work-item';
import { FilterService } from '../../services/filter.service';
import { AppState } from '../../states/app.state';
import { GroupTypeQuery, GroupTypeUI } from './../../models/group-types.model';
import { IterationQuery } from './../../models/iteration.model';
import { SpaceQuery } from './../../models/space';
import { WorkItemPreviewPanelComponent } from './../work-item-preview-panel/work-item-preview-panel.component';
export declare class PlannerBoardComponent implements AfterViewChecked, OnInit, OnDestroy {
    private dragulaService;
    private renderer;
    private spaceQuery;
    private groupTypeQuery;
    private iterationQuery;
    private boardQuery;
    private route;
    private store;
    private router;
    private workItemQuery;
    private boardUiQuery;
    private filterService;
    boardContainer: ElementRef;
    quickPreview: WorkItemPreviewPanelComponent;
    uiLockedSidebar: boolean;
    sidePanelOpen: boolean;
    board$: any;
    private eventListeners;
    private destroy$;
    constructor(dragulaService: DragulaService, renderer: Renderer2, spaceQuery: SpaceQuery, groupTypeQuery: GroupTypeQuery, iterationQuery: IterationQuery, boardQuery: BoardQuery, route: ActivatedRoute, store: Store<AppState>, router: Router, workItemQuery: WorkItemQuery, boardUiQuery: BoardUIQuery, filterService: FilterService);
    ngOnInit(): void;
    setDefaultUrl(groupType: GroupTypeUI): void;
    constructUrl(witGroup: GroupTypeUI): string;
    checkUrl(groupType: any): void;
    ngOnDestroy(): void;
    ngAfterViewChecked(): void;
    togglePanelState(event: any): void;
    openQuickPreview(workItem: WorkItemUI): void;
    onDrop(args: any): void;
}
