import { Component, EventEmitter, Input, Output } from '@angular/core';
var PlannerCardComponent = /** @class */ (function () {
    function PlannerCardComponent() {
        this.onCardClick = new EventEmitter();
        this.onTitleClick = new EventEmitter();
        this.config = {
            noPadding: true,
            topBorder: false,
            titleBorder: false
        };
    }
    PlannerCardComponent.prototype.cardClick = function (workItem, event) {
        event.stopPropagation();
        this.onCardClick.emit(workItem);
    };
    PlannerCardComponent.prototype.titleClick = function (workItem, event) {
        event.stopPropagation();
        this.onTitleClick.emit(workItem);
    };
    PlannerCardComponent.decorators = [
        { type: Component, args: [{
                    selector: 'f8-planner-card',
                    template: require('./planner-card.component.html'),
                    styles: [require('./planner-card.component.css').toString()]
                },] },
    ];
    /** @nocollapse */
    PlannerCardComponent.ctorParameters = function () { return []; };
    PlannerCardComponent.propDecorators = {
        'workItem': [{ type: Input },],
        'onCardClick': [{ type: Output },],
        'onTitleClick': [{ type: Output },],
    };
    return PlannerCardComponent;
}());
export { PlannerCardComponent };
//# sourceMappingURL=planner-card.component.js.map