import { AfterViewChecked, ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { AuthenticationService } from 'ngx-login-client';
import { Observable } from 'rxjs';
import { WorkItemTypeQuery, WorkItemTypeUI } from '../../models/work-item-type';
import { IterationQuery, IterationUI } from './../../models/iteration.model';
import { CookieService } from './../../services/cookie.service';
import { FilterService } from './../../services/filter.service';
import { UrlService } from './../../services/url.service';
import { PlannerLayoutComponent } from './../../widgets/planner-layout/planner-layout.component';
import { Store } from '@ngrx/store';
import { SpaceQuery } from '../../models/space';
import { AreaQuery } from './../../models/area.model';
import { GroupTypeQuery } from './../../models/group-types.model';
import { LabelQuery } from './../../models/label.model';
import { UserQuery } from './../../models/user';
import { WorkItemQuery, WorkItemUI } from './../../models/work-item';
import { AppState } from './../../states/app.state';
import { WorkItemPreviewPanelComponent } from './../work-item-preview-panel/work-item-preview-panel.component';
export declare class PlannerListComponent implements OnInit, OnDestroy, AfterViewChecked {
    private renderer;
    private store;
    private route;
    private router;
    private auth;
    private filterService;
    private cookieService;
    private urlService;
    private iterationQuery;
    private userQuery;
    private labelQuery;
    private workItemQuery;
    private areaQuery;
    private groupTypeQuery;
    private workItemTypeQuery;
    private spaceQuery;
    uiLockedAll: boolean;
    sidePanelOpen: boolean;
    quickAddWorkItemTypes: WorkItemTypeUI[];
    loggedIn: boolean;
    columns: any[];
    workItems: WorkItemUI[];
    contentItemHeight: number;
    selectedRows: any;
    showTreeUI: boolean;
    emptyStateConfig: any;
    uiLockedList: boolean;
    uiLockedSidebar: boolean;
    selectedIterationSource: Observable<IterationUI>;
    private workItemTypeSource;
    private spaceSource;
    private areaSource;
    private labelSource;
    private iterationSource;
    private collaboratorSource;
    private workItemSource;
    private routeSource;
    private eventListeners;
    private detailExpandedRows;
    private showTree;
    private hdrHeight;
    private toolbarHt;
    private quickaddHt;
    private showCompleted;
    plannerLayout: PlannerLayoutComponent;
    toolbar: ElementRef;
    quickaddWrapper: ElementRef;
    listContainer: ElementRef;
    table: any;
    quickPreview: WorkItemPreviewPanelComponent;
    constructor(renderer: Renderer2, store: Store<AppState>, route: ActivatedRoute, router: Router, auth: AuthenticationService, filterService: FilterService, cookieService: CookieService, urlService: UrlService, iterationQuery: IterationQuery, userQuery: UserQuery, labelQuery: LabelQuery, workItemQuery: WorkItemQuery, areaQuery: AreaQuery, groupTypeQuery: GroupTypeQuery, workItemTypeQuery: WorkItemTypeQuery, spaceQuery: SpaceQuery);
    ngOnInit(): void;
    handleReorder(event: any): void;
    moveToDisplay(columns: any): void;
    moveToAvailable(columns: any): void;
    togglePanelState(event: any): void;
    togglePanel(): void;
    setDefaultUrl(): void;
    setWorkItemTypes(): void;
    /**
     * This function listens for any change in
     * work item state and adopt it
    */
    setWorkItems(): void;
    setDataTableColumns(): void;
    onSelect({ selected }: {
        selected: any;
    }): void;
    onScroll(event: any): void;
    onTreeAction(event: any): void;
    loadChildren(workItem: WorkItemUI): void;
    toggleExpandRow(row: any, quickAddEnabled?: boolean): void;
    onCreateStart(): void;
    onClickLabel(event: any): void;
    onPreview(workItem: WorkItemUI): void;
    onRowDrop(event: any): void;
    ngOnDestroy(): void;
    ngAfterViewChecked(): void;
    onResize(event: any): void;
}
