import { AfterViewChecked, AfterViewInit, ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Store } from '@ngrx/store';
import { EmptyStateConfig } from 'patternfly-ng';
import { Observable } from 'rxjs';
import { PermissionQuery } from '../../models/permission.model';
import { SpaceQuery } from '../../models/space';
import { WorkItemQuery, WorkItemUI } from '../../models/work-item';
import { WorkItemTypeQuery, WorkItemTypeUI } from '../../models/work-item-type';
import { CookieService } from '../../services/cookie.service';
import { FilterService } from '../../services/filter.service';
import { UrlService } from '../../services/url.service';
import { AppState } from '../../states/app.state';
import { WorkItemPreviewPanelComponent } from './../work-item-preview-panel/work-item-preview-panel.component';
export declare class PlannerQueryComponent implements OnInit, OnDestroy, AfterViewChecked, AfterViewInit {
    private cookieService;
    private spaceQuery;
    private router;
    private route;
    private workItemQuery;
    private store;
    private filterService;
    private renderer;
    private workItemTypeQuery;
    private urlService;
    private el;
    private permissionQuery;
    quickPreview: WorkItemPreviewPanelComponent;
    listContainer: ElementRef;
    querySearchRef: ElementRef;
    workItemsSource: Observable<WorkItemUI[]>;
    quickAddWorkItemTypes: Observable<WorkItemTypeUI[]>;
    currentQuery: string;
    breadcrumbs: any[];
    disableInput: boolean;
    uiLockedList: boolean;
    emptyStateConfig: EmptyStateConfig;
    contentItemHeight: number;
    columns: any[];
    selectedRows: any;
    searchQuery: string;
    isCreateWorkitemDropdownOpen: boolean;
    _lastCheckedScrollHeight: any;
    _scrollTrigger: number;
    headerHeight: number;
    targetHeight: number;
    addDisabled: Observable<boolean>;
    private eventListeners;
    private hdrHeight;
    private querySearchRefHt;
    private initialPageSize;
    private filters;
    private scrollCheckedFor;
    private isQuickPreviewOpen;
    constructor(cookieService: CookieService, spaceQuery: SpaceQuery, router: Router, route: ActivatedRoute, workItemQuery: WorkItemQuery, store: Store<AppState>, filterService: FilterService, renderer: Renderer2, workItemTypeQuery: WorkItemTypeQuery, urlService: UrlService, el: ElementRef, permissionQuery: PermissionQuery);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onPreview(workItem: WorkItemUI): void;
    closePreview(): void;
    setDataTableColumns(): void;
    handleReorder(event: any): void;
    fetchWorkItemForQuery(event: KeyboardEvent, query: string): void;
    onChildExploration(workItem: WorkItemUI): void;
    navigateToQuery(query: any): void;
    closeCreateWorkItemDialog(event: MouseEvent): void;
    createWorkItemDialogChange(value: boolean): void;
    breadcrumbsText(index: any, query: any): string;
    checkPageSize(event: any): void;
    onScroll(offsetY: number, numberOfItems: number): void;
    fetchMoreItems(): void;
    ngAfterViewChecked(): void;
    ngAfterViewInit(): void;
    onResize(event: any): void;
}
