import { EventEmitter } from '@angular/core';
export declare class TableConfigComponent {
    columns: any;
    readonly onMovetoAvailable: EventEmitter<any[]>;
    readonly onMovetoDisplay: EventEmitter<any[]>;
    private isTableConfigOpen;
    /**
     * set selected prop true of checked column
     * @param event native event of checkbox
     * @param col column object
     */
    toggleCheckbox(event: any, col: any): void;
    /**
     * set display property true of selected cols
     * shows these column in table
     */
    moveToDisplay(): void;
    /**
     * set available property true and display property false of selected columns
     * dont show these col in table
     */
    moveToAvailable(): void;
    /**
     * update the index of column with prop display: true
     * set index undefined for col with prop display: false
     *  i.e. hidden columns
     */
    updateColumnIndex(): void;
    tableConfigChange(value: boolean): void;
    tableConfigToggle(event: MouseEvent): void;
    clickOut(): void;
}
