import { Component, Input } from '@angular/core';
import { Store } from '@ngrx/store';
import { EventQuery } from '../../models/event.model';
import * as EventActions from './../../actions/event.action';
var WorkItemEventWrapperComponent = /** @class */ (function () {
    function WorkItemEventWrapperComponent(store, eventsQuery) {
        this.store = store;
        this.eventsQuery = eventsQuery;
        this.workitem = null;
        this.events = this.eventsQuery.getEventsWithModifier();
    }
    Object.defineProperty(WorkItemEventWrapperComponent.prototype, "WorkItem", {
        set: function (workitem) {
            this.workitem = workitem;
            this.store.dispatch(new EventActions.Get(this.workitem.eventLink));
        },
        enumerable: true,
        configurable: true
    });
    WorkItemEventWrapperComponent.prototype.ngOnInit = function () {
        this.emptyStateConfig = {
            info: 'There are no Audits for your selected work item',
            title: 'No Audits Available'
        };
    };
    WorkItemEventWrapperComponent.decorators = [
        { type: Component, args: [{
                    selector: 'work-item-event-wrapper',
                    template: require('./work-item-event-wrapper.component.html'),
                    styles: [require('./work-item-event-wrapper.component.css').toString()]
                },] },
    ];
    /** @nocollapse */
    WorkItemEventWrapperComponent.ctorParameters = function () { return [
        { type: Store, },
        { type: EventQuery, },
    ]; };
    WorkItemEventWrapperComponent.propDecorators = {
        'WorkItem': [{ type: Input, args: ['workItem',] },],
    };
    return WorkItemEventWrapperComponent;
}());
export { WorkItemEventWrapperComponent };
//# sourceMappingURL=work-item-event-wrapper.component.js.map