import { animate, state, style, transition, trigger } from '@angular/animations';
import { Component, EventEmitter, HostListener, Input, Output } from '@angular/core';
var WorkItemPreviewPanelComponent = /** @class */ (function () {
    function WorkItemPreviewPanelComponent() {
        this.context = 'list';
        this.onOpen = new EventEmitter();
        this.onClose = new EventEmitter();
        this.panelState = 'out';
        this.workItem = null;
    }
    WorkItemPreviewPanelComponent.prototype.ngOnInit = function () {
    };
    WorkItemPreviewPanelComponent.prototype.open = function (workItem) {
        if (workItem) {
            this.workItem = workItem;
            if (this.panelState === 'out') {
                this.panelState = 'in';
                this.onOpen.emit();
            }
        }
    };
    WorkItemPreviewPanelComponent.prototype.close = function () {
        this.panelState = 'out';
        this.workItem = null;
        this.onClose.emit();
    };
    WorkItemPreviewPanelComponent.prototype.onKeyEvent = function (event) {
        event = (event || window.event);
        // for ESC key handling
        if (event.keyCode == 27) {
            this.close();
        }
    };
    WorkItemPreviewPanelComponent.decorators = [
        { type: Component, args: [{
                    selector: 'work-item-preview-panel',
                    template: require('./work-item-preview-panel.component.html'),
                    styles: [require('./work-item-preview-panel.component.css').toString()],
                    animations: [
                        trigger('slideInOut', [
                            state('in', style({
                                transform: 'translateX(0px)',
                                left: 'auto'
                            })),
                            state('out', style({
                                transform: 'translateX(100%)',
                                left: '100%'
                            })),
                            transition('in => out', animate('200ms ease-in-out')),
                            transition('out => in', animate('200ms ease-in-out'))
                        ])
                    ]
                },] },
    ];
    /** @nocollapse */
    WorkItemPreviewPanelComponent.ctorParameters = function () { return []; };
    WorkItemPreviewPanelComponent.propDecorators = {
        'context': [{ type: Input },],
        'onOpen': [{ type: Output, args: ['onOpen',] },],
        'onClose': [{ type: Output, args: ['onClose',] },],
        'onKeyEvent': [{ type: HostListener, args: ['window:keydown', ['$event'],] },],
    };
    return WorkItemPreviewPanelComponent;
}());
export { WorkItemPreviewPanelComponent };
//# sourceMappingURL=work-item-preview-panel.component.js.map