import { AfterViewChecked, AfterViewInit, ElementRef, EventEmitter, OnDestroy, OnInit, QueryList, Renderer2 } from '@angular/core';
import { Logger } from 'ngx-base';
import { WorkItemService } from '../../models/work-item';
import { WorkItemTypeUI } from '../../models/work-item-type';
import { IterationUI } from './../../models/iteration.model';
import { PermissionQuery } from './../../models/permission.model';
import { WorkItemQuery } from './../../models/work-item';
import { FormControl } from '@angular/forms';
import { Store } from '@ngrx/store';
import { Observable } from 'rxjs';
import { AppState } from './../../states/app.state';
export declare class WorkItemQuickAddComponent implements OnInit, OnDestroy, AfterViewInit, AfterViewChecked {
    private logger;
    private renderer;
    private store;
    private workItemQuery;
    private permissionQuery;
    qaTitle: any;
    qaDesc: any;
    qaTitleRef: QueryList<ElementRef>;
    quickAddElement: ElementRef;
    inlinequickAddElement: ElementRef;
    parentWorkItemId: string;
    workItemTypes: WorkItemTypeUI[];
    selectedType: WorkItemTypeUI;
    selectedIteration: IterationUI;
    wilistview: string;
    readonly onStartCreateWI: EventEmitter<any>;
    error: any;
    workItem: WorkItemService;
    validTitle: boolean;
    linkObject: object;
    addDisabled: Observable<boolean>;
    workItemTitle: FormControl;
    initialDescHeight: number;
    initialDescHeightDiff: number;
    descHeight: any;
    descResize: any;
    showQuickAdd: boolean;
    createId: number;
    eventListeners: any[];
    blockAdd: boolean;
    infotipSource: Observable<any>;
    constructor(logger: Logger, renderer: Renderer2, store: Store<AppState>, workItemQuery: WorkItemQuery, permissionQuery: PermissionQuery);
    ngOnInit(): void;
    ngOnDestroy(): void;
    setTypeContext(type: any): void;
    createWorkItemObj(): void;
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    selectType(event: any, type: WorkItemTypeUI): void;
    save(event?: any, openStatus?: boolean): void;
    checkTitle(): void;
    resetQuickAdd(): void;
    preventDef(event: any): void;
    checkDesc(): void;
    getInfotipText(id: string): Observable<any>;
}
