import { Actions } from '@ngrx/effects';
import { Observable } from 'rxjs';
import { SpaceQuery } from '../models/space';
import * as WorkItemLinkActions from './../actions/work-item-link.actions';
import * as WorkItemActions from './../actions/work-item.actions';
import { WorkItemQuery } from './../models/work-item';
import { WorkItemService } from './../services/work-item.service';
import { ErrorHandler } from './work-item-utils';
export declare type Action = WorkItemLinkActions.All;
export declare class WorkItemLinkEffects {
    private actions$;
    private workItemService;
    private workItemQuery;
    private spaceQuery;
    private errHandler;
    private wilMapper;
    constructor(actions$: Actions, workItemService: WorkItemService, workItemQuery: WorkItemQuery, spaceQuery: SpaceQuery, errHandler: ErrorHandler);
    getLinks$: Observable<Action>;
    createLink$: Observable<Action | WorkItemActions.CreateLink>;
    deleteLink$: Observable<Action | WorkItemActions.DeleteLink>;
}
