import { Injectable } from '@angular/core';
import { map } from 'rxjs/operators';
import { HttpClientService } from '../shared/http-module/http.service';
var BoardService = /** @class */ (function () {
    function BoardService(http) {
        this.http = http;
    }
    /**
     * Usage: this is used to get the board API url from spacetemplate response
     * @param spaceTemplateApiUrl
     */
    BoardService.prototype.getBoardApiUrl = function (spaceTemplateApiUrl) {
        return this.http.get(spaceTemplateApiUrl)
            .pipe(map(function (resp) { return resp.data; }), map(function (template) { return template.relationships.workitemboards.links.related; }));
    };
    /**
     * Usage: this is to get the list board for a sapce
     * @param boardUrl
     */
    BoardService.prototype.getBoards = function (boardUrl) {
        return this.http.get(boardUrl)
            .pipe(map(function (resp) {
            return {
                data: resp.data,
                included: resp.included
            };
        }));
    };
    BoardService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    BoardService.ctorParameters = function () { return [
        { type: HttpClientService, },
    ]; };
    return BoardService;
}());
export { BoardService };
//# sourceMappingURL=board.service.js.map