import { Observable } from 'rxjs';
import { CustomQueryModel } from '../models/custom-query.model';
import { HttpClientService } from '../shared/http-module/http.service';
export declare class CustomQueryService {
    private http;
    constructor(http: HttpClientService);
    /**
     * getCustomQueries - Fetches all the available custom queries
     * @param apiUrl - The url to get list of all filters
     * @return Observable of FilterModel[] - Array of filters
     */
    getCustomQueries(apiUrl: any): Observable<CustomQueryModel[]>;
    /**
      * Usage: This method create a new item
      * adds the new item to the big list
      * resolve the users for the item
      * re build the ID-Index map
      *
      * @param: WorkItem - workItem (Item to be created)
      */
    create(customQuery: CustomQueryModel, apiUrl: string): Observable<CustomQueryModel>;
    /**
     * Usage: This method deletes a custom query
     * @param apiUrl ulr to the custom query
     */
    delete(apiUrl: string): Observable<any>;
    /**
     * Error handling
     */
    private handleError;
}
