import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
import { LabelModel } from '../models/label.model';
import { HttpClientService } from './../shared/http-module/http.service';
export declare class LabelService {
    private http;
    constructor(http: HttpClientService);
    /**
     * getLabels - We call this service method to fetch all labels in currect space
     * @return Observable of LabelModel[] - Array of labels.
     * Url - http://localhost:8080/api/spaces/829d2039-3929-4e8e-865b-fd463b8b34f1/labels/
     */
    getLabels(labelUrl: any): Observable<LabelModel[]>;
    createLabel(label: LabelModel, url: string): Observable<LabelModel>;
}
